' スプライトのイメージデータをメモリー配列に定義
IMG_DEFENDER = 0x0000
mdata 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x02, 0x40
mdata 0x04, 0x20, 0x0D, 0xB0, 0x1E, 0x78, 0x1F, 0xF8
mdata 0x3F, 0xFC, 0x7F, 0xFE, 0xF5, 0xAF, 0x60, 0x06
mdata 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
IMG_UFO = getmptr()
mdata 0x00, 0x00, 0x07, 0xE0, 0x08, 0x10, 0x10, 0x08
mdata 0x20, 0x74, 0x41, 0xFA, 0x47, 0xEA, 0x47, 0x9A
mdata 0x4F, 0x3A, 0x4E, 0x6A, 0x4D, 0x82, 0x2F, 0x04
mdata 0x17, 0x88, 0x08, 0x10, 0x07, 0xE0, 0x00, 0x00
IMG_EXPLOSION = getmptr()
mdata 0x00, 0x00, 0x00, 0x80, 0x01, 0xC0, 0x43, 0xE1
mdata 0x01, 0xC0, 0x08, 0x88, 0x00, 0x80, 0x20, 0x02
mdata 0x78, 0x0F, 0x20, 0x02, 0x00, 0x80, 0x08, 0x88
mdata 0x01, 0xC0, 0x43, 0xE1, 0x01, 0xC0, 0x00, 0x80
IMG_BEAM = getmptr()
mdataw -736, -736, -736, -736
mdataw -736, -736, -736, -736
mdataw -736, -736, -736, -736
mdataw -736, -736, -736, -736

' 座標読み出し用のワーク
POS = getmptr()

' 色の定義
ORANGE = rgb(255, 165, 0)
YELLOW = rgb(255, 255, 0)
RED = rgb(255, 0, 0)
GREEN = rgb(0, 255, 0)
WHITE = rgb(255, 255, 255)
BLACK = 0

' ボタンの定義
BUTTON_UP = 5
BUTTON_DOWN = 8
BUTTON_LEFT = 7
BUTTON_RIGHT = 6
BUTTON_A = 11
BUTTON_B = 10
BUTTON_START = 9
BUTTON_SELECT = 3

' スプライト作成
startX = 0 + 1
startY = 16 + 1
endX = 320 - 16 - 1
endY = 240 - 16 - 1
defender = sprnew(0, 160, 120, 16, 16, IMG_DEFENDER, WHITE, BLACK)
ufo1 = sprnew(1, startX, startY, 16, 16, IMG_UFO, YELLOW, BLACK)
ufo2 = sprnew(2, startX, startY, 16, 16, IMG_UFO, ORANGE, BLACK)
ufo3 = sprnew(3, startX, startY, 16, 16, IMG_UFO, GREEN, BLACK)
explosion = sprnew(4, startX, startY, 16, 16, IMG_EXPLOSION, RED, BLACK)
beam = sprnew(5, startX, startY, 4, 4, IMG_BEAM, 0, 0)

' 起動画面
cls
gprint 0, 0, "SCORE:", GREEN
rect 0, 16, 320, 240, RED, 0
sprdsp defender, 1
sprdsp ufo1, 1
sprdsp ufo2, 1
sprdsp ufo3, 1

' メインループ
ufoSpeed = 50
while 1
	gprint 56, 0, score, GREEN
	suspend()
	move(ufo1)
	move(ufo2)
	move(ufo3)
	moveDefender()
	beam()
	hit(defender, ufo1)
	hit(defender, ufo2)
	hit(defender, ufo3)
wend

' UFOの移動
def move(ufo) {
	var x
	var y
	var speed
	speed = ufoSpeed / 10
	x = getX(ufo) + rnd(speed) - speed / 2
	y = getY(ufo) + rnd(speed) - speed / 2
	sprmov ufo, adjustX(x), adjustY(y)
}

' X座標の取得
def getX(obj) {
	sprget obj, POS
	return mpeekw(POS / 2)
}

' Y座標の取得
def getY(obj) {
	sprget obj, POS
	return mpeekw(POS / 2 + 1)
}

' X座標の調整
def adjustX(x) {
	if x < startX then x = endX
	if endX < x then x = startX
	return x
}

' Y座標の調整
def adjustY(y) {
	if y < startY then y = endY
	if endY < y then y = startY
	return y
}

' ディフェンダーの移動
def moveDefender() {
	var x
	var y
	x = getX(defender)
	y = getY(defender)
	nx = x
	ny = y
	if in(BUTTON_UP) = 0 then ny = ny - 1
	if in(BUTTON_DOWN) = 0 then ny = ny + 1
	if in(BUTTON_LEFT) = 0 then nx = nx - 1
	if in(BUTTON_RIGHT) = 0 then nx = nx + 1
	nx = adjustX(nx)
	ny = adjustY(ny)
	if x <> nx or y <> ny then sprmov defender, nx, ny
}

' UFOに当たったときの処理
def hit(obj, ufo) {
	if !sprhit(obj, ufo) then return // 当たっていない
	sprdsp beam, 0
	sprdsp ufo, 0
	sprdsp obj, 0

	if obj = beam then sprmov explosion, getX(ufo), getY(ufo): score = score + 10: ufoSpeed =  ufoSpeed + 1
		else sprmov explosion, getX(obj), getY(obj)
	sprdsp explosion, 1
	beep 10, 100
	beep 12, 100
	beep 15, 100
	pause 1000
	suspend()
	sprdsp explosion, 0
	beep 31, 100
	if obj = defender then gameOver()
	sprmov ufo, startX, startY
	sprdsp ufo, 1
	sprdsp defender, 1
}

' ビーム砲の処理
def beam() {
	var x
	var y
	var sY
	var eY
	var direction
	direction = 0
	x = getX(defender) + 6
	y = getY(defender) - 2
	if in(BUTTON_A) = 0 then sY = y: eY = startY: direction = -2
	if in(BUTTON_B) = 0 then sY = y + 16: eY = endY + 16 - 4: direction = 2
	if direction = 0 then return // ボタンが押されていない
	for i = sY to eY step direction
		suspend()
		sprmov beam, x, i
		sprdsp beam, 1
		move(ufo1)
		move(ufo2)
		move(ufo3)
		moveDefender()
		hit(defender, ufo1)
		hit(defender, ufo2)
		hit(defender, ufo3)
		hit(beam, ufo1)
		hit(beam, ufo2)
		hit(beam, ufo3)
	next
	sprdsp beam, 0
}

' SELECTボタンで中断、STARTボタンで再開
def suspend() {
	if in(BUTTON_SELECT) = 0 then
		while in(BUTTON_START)
		wend
}

' ゲームオーバー
def gameOver() {
 	gprint 120, 0, "GAME OVER", ORANGE
 	gprint 120, 100, "PUSH SATART BUTTON", RED
	beep 1, 1800
	while in(BUTTON_START)
	wend
	end
}
